#ifndef EFL_IO_COPIER_EO_HH
#define EFL_IO_COPIER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_io_closer.eo.h"
#include "efl_io_copier.eo.h"
#include "efl_io_reader.eo.h"
#include "efl_io_writer.eo.h"
#include "efl_loop.eo.h"
#include "efl_loop_user.eo.h"
#include "efl_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_io_closer.eo.hh"
#include "efl_io_reader.eo.hh"
#include "efl_io_writer.eo.hh"
#include "efl_loop.eo.hh"
#include "efl_loop_user.eo.hh"
#include "efl_object.eo.hh"
namespace efl { namespace io { 
struct Copier;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::io::Copier> : ::std::true_type {}; } }
namespace efl { namespace io { 
struct Copier;
} } 
namespace efl { 
struct Loop_User;
} 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Loop;
} 
namespace efl { namespace io { 
struct Closer;
} } 
namespace efl { namespace io { 
struct Reader;
} } 
namespace efl { namespace io { 
struct Writer;
} } 

namespace eo_cxx {
namespace efl { namespace io { 
struct Copier {
   ::efl::eolian::return_traits< ::efl::io::Reader>::type source_get() const;
   ::efl::eolian::return_traits<void>::type source_set( ::efl::eolian::in_traits< ::efl::io::Reader>::type source) const;
   ::efl::eolian::return_traits< ::efl::io::Writer>::type destination_get() const;
   ::efl::eolian::return_traits<void>::type destination_set( ::efl::eolian::in_traits< ::efl::io::Writer>::type destination) const;
   ::efl::eolian::return_traits<Eina_Slice>::type line_delimiter_get() const;
   ::efl::eolian::return_traits<void>::type line_delimiter_set( ::efl::eolian::in_traits<Eina_Slice>::type slice) const;
   ::efl::eolian::return_traits< size_t>::type buffer_limit_get() const;
   ::efl::eolian::return_traits<void>::type buffer_limit_set( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits< size_t>::type read_chunk_size_get() const;
   ::efl::eolian::return_traits<void>::type read_chunk_size_set( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits<void>::type progress_get( ::efl::eolian::out_traits< uint64_t*>::type read,  ::efl::eolian::out_traits< uint64_t*>::type written,  ::efl::eolian::out_traits< uint64_t*>::type total) const;
   ::efl::eolian::return_traits<double>::type timeout_inactivity_get() const;
   ::efl::eolian::return_traits<void>::type timeout_inactivity_set( ::efl::eolian::in_traits<double>::type seconds) const;
   ::efl::eolian::return_traits<bool>::type done_get() const;
   ::efl::eolian::return_traits<void>::type done_set( ::efl::eolian::in_traits<bool>::type done) const;
   ::efl::eolian::return_traits< size_t>::type pending_size_get() const;
   ::efl::eolian::return_traits< ::std::unique_ptr<Eina_Binbuf, ::efl::eina::malloc_deleter>>::type binbuf_steal() const;
   ::efl::eolian::return_traits<bool>::type flush( ::efl::eolian::in_traits<bool>::type may_block,  ::efl::eolian::in_traits<bool>::type ignore_line_delimiter) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_COPIER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::io::Copier() const;
   operator ::efl::io::Copier&();
   operator ::efl::io::Copier const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Copier,  ::efl::Loop_User,  ::efl::Object,  ::efl::io::Closer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Copier const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::io::Closer const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace io { 
struct Copier : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Loop_User)
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::efl ::io::Closer)
{
   explicit Copier( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Copier(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Copier(Copier const& other) = default;
   Copier(Copier&& other) = default;
   Copier& operator=(Copier const& other) = default;
   Copier& operator=(Copier&& other) = default;
   Copier()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Copier( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Copier(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::io::Reader>::type source_get() const;
   ::efl::eolian::return_traits<void>::type source_set( ::efl::eolian::in_traits< ::efl::io::Reader>::type source) const;
   ::efl::eolian::return_traits< ::efl::io::Writer>::type destination_get() const;
   ::efl::eolian::return_traits<void>::type destination_set( ::efl::eolian::in_traits< ::efl::io::Writer>::type destination) const;
   ::efl::eolian::return_traits<Eina_Slice>::type line_delimiter_get() const;
   ::efl::eolian::return_traits<void>::type line_delimiter_set( ::efl::eolian::in_traits<Eina_Slice>::type slice) const;
   ::efl::eolian::return_traits< size_t>::type buffer_limit_get() const;
   ::efl::eolian::return_traits<void>::type buffer_limit_set( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits< size_t>::type read_chunk_size_get() const;
   ::efl::eolian::return_traits<void>::type read_chunk_size_set( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits<void>::type progress_get( ::efl::eolian::out_traits< uint64_t*>::type read,  ::efl::eolian::out_traits< uint64_t*>::type written,  ::efl::eolian::out_traits< uint64_t*>::type total) const;
   ::efl::eolian::return_traits<double>::type timeout_inactivity_get() const;
   ::efl::eolian::return_traits<void>::type timeout_inactivity_set( ::efl::eolian::in_traits<double>::type seconds) const;
   ::efl::eolian::return_traits<bool>::type done_get() const;
   ::efl::eolian::return_traits<void>::type done_set( ::efl::eolian::in_traits<bool>::type done) const;
   ::efl::eolian::return_traits< size_t>::type pending_size_get() const;
   ::efl::eolian::return_traits< ::std::unique_ptr<Eina_Binbuf, ::efl::eina::malloc_deleter>>::type binbuf_steal() const;
   ::efl::eolian::return_traits<bool>::type flush( ::efl::eolian::in_traits<bool>::type may_block,  ::efl::eolian::in_traits<bool>::type ignore_line_delimiter) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_COPIER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct done_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_COPIER_EVENT_DONE; }
      typedef void parameter_type;
   } const done_event;
   static struct error_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_COPIER_EVENT_ERROR; }
      typedef Eina_Error parameter_type;
   } const error_event;
   static struct progress_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_COPIER_EVENT_PROGRESS; }
      typedef void parameter_type;
   } const progress_event;
   static struct data_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_COPIER_EVENT_DATA; }
      typedef Eina_Slice const& parameter_type;
   } const data_event;
   static struct line_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_COPIER_EVENT_LINE; }
      typedef Eina_Slice const& parameter_type;
   } const line_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Copier,  ::efl::Loop_User,  ::efl::Object,  ::efl::io::Closer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Copier const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::io::Closer const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Copier) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Copier>::value, "");
} } 
#endif
