#ifndef EFL_IMAGE_ANIMATED_EO_HH
#define EFL_IMAGE_ANIMATED_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_image_animated.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace image { 
struct Animated;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::image::Animated> : ::std::true_type {}; } }
namespace efl { namespace image { 
struct Animated;
} } 

namespace eo_cxx {
namespace efl { namespace image { 
struct Animated {
   ::efl::eolian::return_traits<bool>::type animated_get() const;
   ::efl::eolian::return_traits<int>::type animated_frame_get() const;
   ::efl::eolian::return_traits<bool>::type animated_frame_set( ::efl::eolian::in_traits<int>::type frame_index) const;
   ::efl::eolian::return_traits<int>::type animated_frame_count_get() const;
   ::efl::eolian::return_traits<Efl_Image_Animated_Loop_Hint>::type animated_loop_type_get() const;
   ::efl::eolian::return_traits<int>::type animated_loop_count_get() const;
   ::efl::eolian::return_traits<double>::type animated_frame_duration_get( ::efl::eolian::in_traits<int>::type start_frame,  ::efl::eolian::in_traits<int>::type frame_num) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IMAGE_ANIMATED_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::image::Animated() const;
   operator ::efl::image::Animated&();
   operator ::efl::image::Animated const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Animated> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Animated const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace image { 
struct Animated : ::efl::eo::concrete
{
   explicit Animated( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Animated(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Animated(Animated const& other) = default;
   Animated(Animated&& other) = default;
   Animated& operator=(Animated const& other) = default;
   Animated& operator=(Animated&& other) = default;
   Animated()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Animated( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Animated(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type animated_get() const;
   ::efl::eolian::return_traits<int>::type animated_frame_get() const;
   ::efl::eolian::return_traits<bool>::type animated_frame_set( ::efl::eolian::in_traits<int>::type frame_index) const;
   ::efl::eolian::return_traits<int>::type animated_frame_count_get() const;
   ::efl::eolian::return_traits<Efl_Image_Animated_Loop_Hint>::type animated_loop_type_get() const;
   ::efl::eolian::return_traits<int>::type animated_loop_count_get() const;
   ::efl::eolian::return_traits<double>::type animated_frame_duration_get( ::efl::eolian::in_traits<int>::type start_frame,  ::efl::eolian::in_traits<int>::type frame_num) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IMAGE_ANIMATED_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Animated> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Animated const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Animated) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Animated>::value, "");
} } 
#endif
