#ifndef EFL_IMAGE_LOAD_EO_HH
#define EFL_IMAGE_LOAD_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_image_load.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace image { 
struct Load;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::image::Load> : ::std::true_type {}; } }
namespace efl { namespace image { 
struct Load;
} } 

namespace eo_cxx {
namespace efl { namespace image { 
struct Load {
   ::efl::eolian::return_traits<void>::type load_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type load_size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<double>::type load_dpi_get() const;
   ::efl::eolian::return_traits<void>::type load_dpi_set( ::efl::eolian::in_traits<double>::type dpi) const;
   ::efl::eolian::return_traits<bool>::type load_region_support_get() const;
   ::efl::eolian::return_traits<void>::type load_region_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type load_region_set( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<bool>::type load_orientation_get() const;
   ::efl::eolian::return_traits<void>::type load_orientation_set( ::efl::eolian::in_traits<bool>::type enable) const;
   ::efl::eolian::return_traits<int>::type load_scale_down_get() const;
   ::efl::eolian::return_traits<void>::type load_scale_down_set( ::efl::eolian::in_traits<int>::type div) const;
   ::efl::eolian::return_traits<Efl_Image_Load_Error>::type load_error_get() const;
   ::efl::eolian::return_traits<bool>::type load_skip_header_get() const;
   ::efl::eolian::return_traits<void>::type load_skip_header_set( ::efl::eolian::in_traits<bool>::type skip) const;
   ::efl::eolian::return_traits<void>::type load_async_start() const;
   ::efl::eolian::return_traits<void>::type load_async_cancel() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IMAGE_LOAD_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::image::Load() const;
   operator ::efl::image::Load&();
   operator ::efl::image::Load const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Load> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Load const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace image { 
struct Load : ::efl::eo::concrete
{
   explicit Load( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Load(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Load(Load const& other) = default;
   Load(Load&& other) = default;
   Load& operator=(Load const& other) = default;
   Load& operator=(Load&& other) = default;
   Load()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Load( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Load(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type load_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type load_size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<double>::type load_dpi_get() const;
   ::efl::eolian::return_traits<void>::type load_dpi_set( ::efl::eolian::in_traits<double>::type dpi) const;
   ::efl::eolian::return_traits<bool>::type load_region_support_get() const;
   ::efl::eolian::return_traits<void>::type load_region_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type load_region_set( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<bool>::type load_orientation_get() const;
   ::efl::eolian::return_traits<void>::type load_orientation_set( ::efl::eolian::in_traits<bool>::type enable) const;
   ::efl::eolian::return_traits<int>::type load_scale_down_get() const;
   ::efl::eolian::return_traits<void>::type load_scale_down_set( ::efl::eolian::in_traits<int>::type div) const;
   ::efl::eolian::return_traits<Efl_Image_Load_Error>::type load_error_get() const;
   ::efl::eolian::return_traits<bool>::type load_skip_header_get() const;
   ::efl::eolian::return_traits<void>::type load_skip_header_set( ::efl::eolian::in_traits<bool>::type skip) const;
   ::efl::eolian::return_traits<void>::type load_async_start() const;
   ::efl::eolian::return_traits<void>::type load_async_cancel() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IMAGE_LOAD_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct load_done_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IMAGE_LOAD_EVENT_LOAD_DONE; }
      typedef void parameter_type;
   } const load_done_event;
   static struct load_error_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IMAGE_LOAD_EVENT_LOAD_ERROR; }
      typedef Efl_Image_Load_Error parameter_type;
   } const load_error_event;
   static struct load_cancelled_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IMAGE_LOAD_EVENT_LOAD_CANCELLED; }
      typedef void parameter_type;
   } const load_cancelled_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Load> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Load const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Load) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Load>::value, "");
} } 
#endif
