#ifndef EFL_PLAYER_EO_HH
#define EFL_PLAYER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_player.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { 
struct Player;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Player> : ::std::true_type {}; } }
namespace efl { 
struct Player;
} 

namespace eo_cxx {
namespace efl { 
struct Player {
   ::efl::eolian::return_traits<bool>::type playable_get() const;
   ::efl::eolian::return_traits<bool>::type play_get() const;
   ::efl::eolian::return_traits<void>::type play_set( ::efl::eolian::in_traits<bool>::type play) const;
   ::efl::eolian::return_traits<double>::type position_get() const;
   ::efl::eolian::return_traits<void>::type position_set( ::efl::eolian::in_traits<double>::type sec) const;
   ::efl::eolian::return_traits<double>::type progress_get() const;
   ::efl::eolian::return_traits<double>::type play_speed_get() const;
   ::efl::eolian::return_traits<void>::type play_speed_set( ::efl::eolian::in_traits<double>::type speed) const;
   ::efl::eolian::return_traits<double>::type volume_get() const;
   ::efl::eolian::return_traits<void>::type volume_set( ::efl::eolian::in_traits<double>::type volume) const;
   ::efl::eolian::return_traits<bool>::type mute_get() const;
   ::efl::eolian::return_traits<void>::type mute_set( ::efl::eolian::in_traits<bool>::type mute) const;
   ::efl::eolian::return_traits<double>::type length_get() const;
   ::efl::eolian::return_traits<bool>::type seekable_get() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_PLAYER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Player() const;
   operator ::efl::Player&();
   operator ::efl::Player const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Player> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Player const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Player : ::efl::eo::concrete
{
   explicit Player( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Player(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Player(Player const& other) = default;
   Player(Player&& other) = default;
   Player& operator=(Player const& other) = default;
   Player& operator=(Player&& other) = default;
   Player()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Player( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Player(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type playable_get() const;
   ::efl::eolian::return_traits<bool>::type play_get() const;
   ::efl::eolian::return_traits<void>::type play_set( ::efl::eolian::in_traits<bool>::type play) const;
   ::efl::eolian::return_traits<double>::type position_get() const;
   ::efl::eolian::return_traits<void>::type position_set( ::efl::eolian::in_traits<double>::type sec) const;
   ::efl::eolian::return_traits<double>::type progress_get() const;
   ::efl::eolian::return_traits<double>::type play_speed_get() const;
   ::efl::eolian::return_traits<void>::type play_speed_set( ::efl::eolian::in_traits<double>::type speed) const;
   ::efl::eolian::return_traits<double>::type volume_get() const;
   ::efl::eolian::return_traits<void>::type volume_set( ::efl::eolian::in_traits<double>::type volume) const;
   ::efl::eolian::return_traits<bool>::type mute_get() const;
   ::efl::eolian::return_traits<void>::type mute_set( ::efl::eolian::in_traits<bool>::type mute) const;
   ::efl::eolian::return_traits<double>::type length_get() const;
   ::efl::eolian::return_traits<bool>::type seekable_get() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_PLAYER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Player> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Player const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Player) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Player>::value, "");
} 
#endif
