#ifndef EFL_CONFIG_GLOBAL_EO_HH
#define EFL_CONFIG_GLOBAL_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_config.eo.h"
#include "efl_config_global.eo.h"
#include "efl_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_config.eo.hh"
#include "efl_object.eo.hh"
namespace efl { namespace config { 
struct Global;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::config::Global> : ::std::true_type {}; } }
namespace efl { namespace config { 
struct Global;
} } 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Config;
} 

namespace eo_cxx {
namespace efl { namespace config { 
struct Global {
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type profile_get() const;
   ::efl::eolian::return_traits<void>::type profile_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile) const;
   ::efl::eolian::return_traits<bool>::type save( ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type profile) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::eina::string_view>>::type profile_iterate( ::efl::eolian::in_traits< ::efl::eina::optional<bool>>::type hidden) const;
   ::efl::eolian::return_traits<bool>::type profile_exists( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile) const;
   ::efl::eolian::return_traits< ::efl::eina::stringshare>::type profile_dir_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile,  ::efl::eolian::in_traits<bool>::type is_user) const;
   ::efl::eolian::return_traits<void>::type profile_derived_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type options) const;
   ::efl::eolian::return_traits<void>::type profile_derived_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_CONFIG_GLOBAL_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::config::Global() const;
   operator ::efl::config::Global&();
   operator ::efl::config::Global const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Global,  ::efl::Config,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Global const ,  ::efl::Config const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace config { 
struct Global : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Config)
   , EO_CXX_INHERIT( ::efl::Object)
{
   explicit Global( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Global(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Global(Global const& other) = default;
   Global(Global&& other) = default;
   Global& operator=(Global const& other) = default;
   Global& operator=(Global&& other) = default;
   Global()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Global( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Global(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type profile_get() const;
   ::efl::eolian::return_traits<void>::type profile_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile) const;
   ::efl::eolian::return_traits<bool>::type save( ::efl::eolian::in_traits< ::efl::eina::optional< ::efl::eina::string_view>>::type profile) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::eina::string_view>>::type profile_iterate( ::efl::eolian::in_traits< ::efl::eina::optional<bool>>::type hidden) const;
   ::efl::eolian::return_traits<bool>::type profile_exists( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile) const;
   ::efl::eolian::return_traits< ::efl::eina::stringshare>::type profile_dir_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile,  ::efl::eolian::in_traits<bool>::type is_user) const;
   ::efl::eolian::return_traits<void>::type profile_derived_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type options) const;
   ::efl::eolian::return_traits<void>::type profile_derived_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type profile) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_CONFIG_GLOBAL_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Global,  ::efl::Config,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Global const ,  ::efl::Config const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Global) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Global>::value, "");
} } 
#endif
