#ifndef ELM_GENLIST_ITEM_EO_HH
#define ELM_GENLIST_ITEM_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas_object.eo.h"
#include "efl_interface.eo.h"
#include "efl_object.eo.h"
#include "elm_genlist_item.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "elm_interface_atspi_component.eo.h"
#include "elm_widget_item.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_canvas_object.eo.hh"
#include "efl_interface.eo.hh"
#include "efl_object.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include "elm_widget_item.eo.hh"
namespace elm { namespace genlist { 
struct Item;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::genlist::Item> : ::std::true_type {}; } }
namespace elm { namespace genlist { 
struct Item;
} } 
namespace elm { namespace widget { 
struct Item;
} } 
namespace efl { 
struct Object;
} 
namespace elm { namespace interface { 
struct Atspi_Accessible;
} } 
namespace efl { 
struct Interface;
} 
namespace elm { namespace interface { 
struct Atspi_Component;
} } 
namespace efl { namespace canvas { 
struct Object;
} } 

namespace eo_cxx {
namespace elm { namespace genlist { 
struct Item {
   ::efl::eolian::return_traits< ::elm::widget::Item>::type prev_get() const;
   ::efl::eolian::return_traits< ::elm::widget::Item>::type next_get() const;
   ::efl::eolian::return_traits< ::elm::widget::Item>::type parent_get() const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::elm::widget::Item>>::type subitems_get() const;
   ::efl::eolian::return_traits<bool>::type selected_get() const;
   ::efl::eolian::return_traits<void>::type selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
   ::efl::eolian::return_traits<bool>::type expanded_get() const;
   ::efl::eolian::return_traits<void>::type expanded_set( ::efl::eolian::in_traits<bool>::type expanded) const;
   ::efl::eolian::return_traits<int>::type expanded_depth_get() const;
   ::efl::eolian::return_traits<Elm_Genlist_Item_Class const*>::type item_class_get() const;
   ::efl::eolian::return_traits<int>::type index_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type decorate_mode_get() const;
   ::efl::eolian::return_traits<bool>::type flip_get() const;
   ::efl::eolian::return_traits<void>::type flip_set( ::efl::eolian::in_traits<bool>::type flip) const;
   ::efl::eolian::return_traits<Elm_Object_Select_Mode>::type select_mode_get() const;
   ::efl::eolian::return_traits<void>::type select_mode_set( ::efl::eolian::in_traits<Elm_Object_Select_Mode>::type mode) const;
   ::efl::eolian::return_traits<Elm_Genlist_Item_Type>::type type_get() const;
   ::efl::eolian::return_traits< unsigned int>::type subitems_count() const;
   ::efl::eolian::return_traits<void>::type subitems_clear() const;
   ::efl::eolian::return_traits<void>::type promote() const;
   ::efl::eolian::return_traits<void>::type demote() const;
   ::efl::eolian::return_traits<void>::type show( ::efl::eolian::in_traits<Elm_Genlist_Item_Scrollto_Type>::type type) const;
   ::efl::eolian::return_traits<void>::type bring_in( ::efl::eolian::in_traits<Elm_Genlist_Item_Scrollto_Type>::type type) const;
   ::efl::eolian::return_traits<void>::type all_contents_unset( ::efl::eolian::out_traits<  ::efl::eina::list< ::efl::canvas::Object>>::type l) const;
   ::efl::eolian::return_traits<void>::type update() const;
   ::efl::eolian::return_traits<void>::type fields_update( ::efl::eolian::in_traits< ::efl::eina::string_view>::type parts,  ::efl::eolian::in_traits<Elm_Genlist_Item_Field_Type>::type itf) const;
   ::efl::eolian::return_traits<void>::type item_class_update( ::efl::eolian::in_traits<Elm_Genlist_Item_Class const*>::type itc) const;
   ::efl::eolian::return_traits<void>::type decorate_mode_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type decorate_it_type,  ::efl::eolian::in_traits<bool>::type decorate_it_set) const;
   static Efl_Class const* _eo_class()
   {
      return ELM_GENLIST_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::genlist::Item() const;
   operator ::elm::genlist::Item&();
   operator ::elm::genlist::Item const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::efl::Interface,  ::efl::Object,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::elm::widget::Item> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::efl::Interface const ,  ::efl::Object const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::elm::widget::Item const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace genlist { 
struct Item : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Interface)
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Component)
   , EO_CXX_INHERIT( ::elm ::widget::Item)
{
   explicit Item( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Item(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Item(Item const& other) = default;
   Item(Item&& other) = default;
   Item& operator=(Item const& other) = default;
   Item& operator=(Item&& other) = default;
   Item()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Item( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Item(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::elm::widget::Item>::type prev_get() const;
   ::efl::eolian::return_traits< ::elm::widget::Item>::type next_get() const;
   ::efl::eolian::return_traits< ::elm::widget::Item>::type parent_get() const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::elm::widget::Item>>::type subitems_get() const;
   ::efl::eolian::return_traits<bool>::type selected_get() const;
   ::efl::eolian::return_traits<void>::type selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
   ::efl::eolian::return_traits<bool>::type expanded_get() const;
   ::efl::eolian::return_traits<void>::type expanded_set( ::efl::eolian::in_traits<bool>::type expanded) const;
   ::efl::eolian::return_traits<int>::type expanded_depth_get() const;
   ::efl::eolian::return_traits<Elm_Genlist_Item_Class const*>::type item_class_get() const;
   ::efl::eolian::return_traits<int>::type index_get() const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type decorate_mode_get() const;
   ::efl::eolian::return_traits<bool>::type flip_get() const;
   ::efl::eolian::return_traits<void>::type flip_set( ::efl::eolian::in_traits<bool>::type flip) const;
   ::efl::eolian::return_traits<Elm_Object_Select_Mode>::type select_mode_get() const;
   ::efl::eolian::return_traits<void>::type select_mode_set( ::efl::eolian::in_traits<Elm_Object_Select_Mode>::type mode) const;
   ::efl::eolian::return_traits<Elm_Genlist_Item_Type>::type type_get() const;
   ::efl::eolian::return_traits< unsigned int>::type subitems_count() const;
   ::efl::eolian::return_traits<void>::type subitems_clear() const;
   ::efl::eolian::return_traits<void>::type promote() const;
   ::efl::eolian::return_traits<void>::type demote() const;
   ::efl::eolian::return_traits<void>::type show( ::efl::eolian::in_traits<Elm_Genlist_Item_Scrollto_Type>::type type) const;
   ::efl::eolian::return_traits<void>::type bring_in( ::efl::eolian::in_traits<Elm_Genlist_Item_Scrollto_Type>::type type) const;
   ::efl::eolian::return_traits<void>::type all_contents_unset( ::efl::eolian::out_traits<  ::efl::eina::list< ::efl::canvas::Object>>::type l) const;
   ::efl::eolian::return_traits<void>::type update() const;
   ::efl::eolian::return_traits<void>::type fields_update( ::efl::eolian::in_traits< ::efl::eina::string_view>::type parts,  ::efl::eolian::in_traits<Elm_Genlist_Item_Field_Type>::type itf) const;
   ::efl::eolian::return_traits<void>::type item_class_update( ::efl::eolian::in_traits<Elm_Genlist_Item_Class const*>::type itc) const;
   ::efl::eolian::return_traits<void>::type decorate_mode_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type decorate_it_type,  ::efl::eolian::in_traits<bool>::type decorate_it_set) const;
   static Efl_Class const* _eo_class()
   {
      return ELM_GENLIST_ITEM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item,  ::efl::Interface,  ::efl::Object,  ::elm::interface::Atspi_Accessible,  ::elm::interface::Atspi_Component,  ::elm::widget::Item> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const ,  ::efl::Interface const ,  ::efl::Object const ,  ::elm::interface::Atspi_Accessible const ,  ::elm::interface::Atspi_Component const ,  ::elm::widget::Item const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Item) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Item>::value, "");
} } 
#endif
